<?php

/*
Plugin Name: Checkout - Newsletters Subscribers
Plugin URI: http://tribulant.com/extensions/view/25/newsletters-subscribers
Author: Tribulant Software
Author URI: http://tribulant.com
Description: Capture subscribers into the Newsletter plugin from customers of the <a href="http://tribulant.com/plugins/view/10/wordpress-shopping-cart-plugin">Shopping Cart plugin</a>.
Version: 1.1
*/

if (!defined('DS')) { define('DS', DIRECTORY_SEPARATOR); }
if (!defined('CHECKOUT_EXTENSION_URL')) { define('CHECKOUT_EXTENSION_URL', "http://tribulant.com/extensions/"); }

if (!class_exists('wpconewsletters')) {
	require_once WP_CONTENT_DIR . DS . 'plugins' . DS . 'wp-checkout' . DS . 'wp-checkout.php';

	class wpconewsletters extends wpCheckoutPlugin {
		
		function wpconewsletters() {
			$this -> sections = (object) $this -> sections;
			$this -> plugin_name = basename(dirname(__FILE__));
			$this -> version = '1.1';
		}
		
		function activation_hook() {
			require_once ABSPATH . 'wp-admin' . DS . 'admin-functions.php';
			$path = 'wp-checkout' . DS . 'wp-checkout.php';
			$path2 = 'wp-mailinglist' . DS . 'wp-mailinglist.php';
			
			if (!is_plugin_active(plugin_basename($path)) || 
				!is_plugin_active(plugin_basename($path2))) {
				_e('You must have the Newsletter plugin and Shopping Cart plugin installed and activated in order to use this.', $this -> plugin_name);
				exit(); die();
			} else {		
				$plugin_data = get_plugin_data(WP_CONTENT_DIR . DS . 'plugins' . DS . $path);
				$plugin_version = $plugin_data['Version'];
				$plugin_data2 = get_plugin_data(WP_CONTENT_DIR . DS . 'plugins' . DS . $path2);
				$plugin_version2 = $plugin_data2['Version'];
				$checkout_required = '1.7';
				$newsletters_required = '4.0';
				
				$versiongood = false;
				if (version_compare($plugin_version, $checkout_required) >= 0 && 
					version_compare($plugin_version2, $newsletters_required) >= 0) {
					$versiongood = true;	
				}
				
				if ($versiongood == true) {
					add_option('wpco_newsletters_checkbox', "Y");
					add_option('wpco_newsletters_checkboxlabel', __('Subscribe me to your newsletter', $this -> plugin_name));
					add_option('wpco_newsletters_checkboxautocheck', "N");
				} else {
					echo sprintf(__('The %s extension requires the Shopping Cart plugin %s and Newsletter plugin %s at least.', $this -> plugin_name), 'Newsletters Subscribers', $checkout_required, $newsletters_required);
					exit(); die();	
				}
			}
			
			return true;
		}
		
		function after_plugin_row($plugin_name = null) {		
	        $key = $this -> get_option('serialkey');
	        $update = $this -> vendor('update');
	        $version_info = $update -> get_version_info();
	    }
		
		function display_changelog() {  
			if (!empty($_GET['plugin']) && $_GET['plugin'] == $this -> plugin_name) { 		 
		    	require_once dirname(__FILE__) . DS . 'vendors' . DS . 'class.update.php';
				$update = new wpconewsletters_update();
		    	$changelog = $update -> get_changelog();
		    	
		    	echo '<div style="font-family:Arial, Helvetica, sans-serif; font-size:13px;">';
		    	echo $changelog;
		    	echo '</div>';
		    	
		    	exit();
		    }
	    }
		
		function has_update($cache = true) {
			require_once dirname(__FILE__) . DS . 'vendors' . DS . 'class.update.php';
			$update = new wpconewsletters_update();
	        $version_info = $update -> get_version_info($cache);
	        return version_compare($this -> version, $version_info["version"], '<');
	    }
		
		function check_update($option, $cache = true) {
			require_once dirname(__FILE__) . DS . 'vendors' . DS . 'class.update.php';
			$update = new wpconewsletters_update();
	        $version_info = $update -> get_version_info($cache);
	
	        if (!$version_info) { return $option; }
	
	        $plugin_path = $this -> plugin_name . '/newsletters.php';
	        
	        if(empty($option -> response[$plugin_path])) {
				$option -> response[$plugin_path] = new stdClass();
	        }
	
	        //Empty response means that the key is invalid. Do not queue for upgrade
	        if(!$version_info["is_valid_key"] || version_compare($this -> version, $version_info["version"], '>=')){
	            unset($option -> response[$plugin_path]);
	        } else {
	            $option -> response[$plugin_path] -> url = "http://tribulant.com";
	            $option -> response[$plugin_path] -> slug = $this -> plugin_name;
	            $option -> response[$plugin_path] -> package = $version_info['url'];
	            $option -> response[$plugin_path] -> new_version = $version_info["version"];
	            $option -> response[$plugin_path] -> id = "0";
	        }
	
	        return $option;
	    }
		
		function metaboxes_extensions_settings($page = null) {
			add_meta_box('newsletters', '<img src="' . plugins_url() . '/' . $this -> plugin_name . '/images/icon-16.png" /> ' . __('Newsletters Subscribers', $this -> plugin_name), array($this, 'extensions_settings'), $page, 'normal', 'core');
		}
		
		function extensions_settings() {
			$this -> render('views' . DS . 'settings', false, true, false, 'newsletters');
		}
		
		function contacts_before_register_button($order_id = null, $errors = null) {
			$guestcheckout = $this -> get_option('guestcheckout');
			
			if (empty($guestcheckout) || $guestcheckout == "N") {
				$this -> subscribe_checkbox('contacts', $errors);
			}
		}
		
		function shipping_after_global($order_id = null, $errors = null) {
			global $Order;
			$guestcheckout = $this -> get_option('guestcheckout');
			
			if ($guestcheckout == "Y" && $Order -> do_shipping($order_id)) {
				$this -> subscribe_checkbox('shipping', $errors);
			}
		}
		
		function billing_after_global($order_id = null, $errors = null) {
			global $Order;
			$guestcheckout = $this -> get_option('guestcheckout');
			
			if ($guestcheckout == "Y" && !$Order -> do_shipping($order_id)) {
				$this -> subscribe_checkbox('billing', $errors);
			}
		}
		
		function subscribe_checkbox($place = 'contacts', $errors = null) {
			if ($this -> get_option('newsletters_checkbox') == "Y") {
				$this -> render('views' . DS . 'subscribe-checkbox', array('errors' => $errors), true, false, 'newsletters');
			}
		}
		
		function extensions_list($extensions = array()) {
			$extensions['newsletters'] = array(
				'name'			=>	__('Newsletters Subscribers', $this -> plugin_name),
				'link'			=>	"http://tribulant.com/extensions/view/25/newsletters-subscribers",
				'image'			=>	plugins_url() . '/' . $this -> plugin_name . '/images/icon.png',
				'description'	=>	sprintf(__("Capture customers as subscribers in your %sNewsletter plugin%s.", $this -> plugin_name), '<a href="http://tribulant.com/plugins/view/1/wordpress-newsletter-plugin" target="_blank">', '</a>'),
				'slug'			=>	'newsletters',
				'plugin_name'	=>	$this -> plugin_name,
				'plugin_file'	=>	'newsletters.php',
				'settings'		=>	'?page=' . $this -> sections -> extensions_settings . '#newsletters',
			);
			
			$titles = array();
			foreach ($extensions as $extension) {
				$titles[] = $extension['name'];
			}
			
			array_multisort($titles, SORT_ASC, $extensions);
			return $extensions;
		}
		
		function plugin_action_links($actions = null, $plugin_file = null, $plugin_data = null, $context = null) {
			$this_plugin = plugin_basename(__FILE__);
			
			if (!empty($plugin_file) && $plugin_file == $this_plugin) {
				$actions[] = '<a href="' . wp_nonce_url('admin.php?page=' . $this -> sections -> extensions_settings) . '#newsletters">' . __('Settings', $this -> plugin_name) . '</a>';
			}
			
			return $actions;
		}
		
		function contacts_register_validation($errors = null, $post = null, $co_id = null) {		
			if (empty($errors) && !empty($post['newsletters'])) {			
				$data = array(
					'email'			=>	$_POST['email'],
					'list_id'		=>	$this -> get_option('newsletters_mailinglists'),
				);
				
				$newsletters_errors = $this -> subscribe($data);
				
				if (!empty($newsletters_errors)) {
					reset($newsletters_errors);
					$errors['newsletters'] = $newsletters_errors[key($newsletters_errors)];
				}
			}
			
			return $errors;
		}
		
		function shipping_validation($errors = null, $post = null, $order_id = null) {
			if (empty($errors) && empty($_GET['updateshipping']) && !empty($post['newsletters'])) {			
				$data = array(
					'email'			=>	$_POST['wpcoshipping']['email'],
					'list_id'		=>	$this -> get_option('newsletters_mailinglists'),
				);
				
				$newsletters_errors = $this -> subscribe($data);
				
				if (!empty($newsletters_errors)) {
					reset($newsletters_errors);
					$errors['newsletters'] = $newsletters_errors[key($newsletters_errors)];
				}
			}
			
			return $errors;
		}
		
		function billing_validation($errors = null, $post = null, $order_id = null) {
			if (empty($errors) && empty($_GET['updatebilling']) && !empty($post['newsletters'])) {			
				$data = array(
					'email'			=>	$_POST['wpcobilling']['email'],
					'list_id'		=>	$this -> get_option('newsletters_mailinglists'),
				);
				
				$newsletters_errors = $this -> subscribe($data);
				
				if (!empty($newsletters_errors)) {
					reset($newsletters_errors);
					$errors['newsletters'] = $newsletters_errors[key($newsletters_errors)];
				}
			}
			
			return $errors;
		}
		
		function subscribe($data = null) {
			if (class_exists('wpMail')) {
				$wpMail = new wpMail();
				global $Subscriber;
				$Subscriber -> optin($data, false, false, true);
				return $Subscriber -> errors;
			}
		}
	}
	
	$wpconewsletters = new wpconewsletters();
	register_activation_hook(__FILE__, array($wpconewsletters, 'activation_hook'));
}

$plugin = plugin_basename(basename(dirname(__FILE__)) . '/newsletters.php');
add_action('after_plugin_row_' . $plugin, array($wpconewsletters, 'after_plugin_row'), 10, 2);
add_action('install_plugins_pre_plugin-information', array($wpconewsletters, 'display_changelog'), 10, 1);
add_filter('transient_update_plugins', array($wpconewsletters, 'check_update'), 10, 1);
add_filter('site_transient_update_plugins', array($wpconewsletters, 'check_update'), 10, 1);
add_action('wpco_metaboxes_extensions_settings', array($wpconewsletters, 'metaboxes_extensions_settings'), 10, 1);
add_action('wpco_contacts_before_register_button', array($wpconewsletters, 'contacts_before_register_button'), 10, 2);
add_action('wpco_shipping_after_global', array($wpconewsletters, 'shipping_after_global'), 10, 2);
add_action('wpco_billing_after_global', array($wpconewsletters, 'billing_after_global'), 10, 2);
add_filter('wpco_extensions_list', array($wpconewsletters, 'extensions_list'), 10, 1);
add_filter('wpml_extensions_list', array($wpconewsletters, 'extensions_list'), 10, 1);
add_filter('plugin_action_links', array($wpconewsletters, 'plugin_action_links'), 10, 4);
add_filter('wpco_contacts_register_validation', array($wpconewsletters, 'contacts_register_validation'), 10, 3);
add_filter('wpco_shipping_validation', array($wpconewsletters, 'shipping_validation'), 10, 3);
add_filter('wpco_billing_validation', array($wpconewsletters, 'billing_validation'), 10, 3);

?>